Index: app_voicemail.c
===================================================================
--- app_voicemail.c	(revision 113925)
+++ app_voicemail.c	(working copy)
@@ -5699,72 +5699,88 @@
 	return res;
 }
 
-static int get_lastdigits(int num)
+static int slavic_counted_noun(int num)
 {
+    	if(num < 0)
+	    num *= -1;
 	num %= 100;
-	return (num < 20) ? num : num % 10;
+	if (num >= 20)
+	    num %= 10;
+	if (num == 1)
+	    return 0;
+	if (num > 0 && num < 5)
+	    return 1;
+	else
+	    return 2;
 }
 
+static int slavic_counted_adjective(int num)
+{
+    	if(num < 0)
+	    num *= -1;
+	num %= 100;
+	if (num >= 20)
+	    num %= 10;
+	if(num == 1)
+	    return 0;
+	else
+	    return 1;
+}
+
+/* RUSSIAN syntax
+ *
+ * vm-novoe		"new", singular, neuter
+ * vm-novyh		"new", plural, neuter
+ * vm-soobshenie	"message" (singular form)
+ * vm-soobsheniya	"messages" (first plural form)
+ * vm-soobsheniy	"messages" (second plural form)
+ *
+ * Note that you must also have digits/1o since the Russian word for message
+ * is neuter.
+ */
 static int vm_intro_ru(struct ast_channel *chan,struct vm_state *vms)
 {
 	int res;
 	int lastnum = 0;
-	int dcnum;
 
 	res = ast_play_and_wait(chan, "vm-youhave");
+
 	if (!res && vms->newmessages) {
-		lastnum = get_lastdigits(vms->newmessages);
-		dcnum = vms->newmessages - lastnum;
-		if (dcnum)
-			res = say_and_wait(chan, dcnum, chan->language);
-		if (!res && lastnum) {
-			if (lastnum == 1) 
-				res = ast_play_and_wait(chan, "digits/ru/odno");
-			else
-				res = say_and_wait(chan, lastnum, chan->language);
-		}
+	    	lastnum = vms->newmessages;
 
+		res = ast_say_number(chan, vms->newmessages, AST_DIGIT_ANY, chan->language, "o");
+
 		if (!res)
-			res = ast_play_and_wait(chan, (lastnum == 1) ? "vm-novoe" : "vm-novyh");
+			res = ast_play_and_wait(chan, slavic_counted_adjective(vms->newmessages) ? "vm-novyh" : "vm-novoe");
 
 		if (!res && vms->oldmessages)
 			res = ast_play_and_wait(chan, "vm-and");
 	}
 
 	if (!res && vms->oldmessages) {
-		lastnum = get_lastdigits(vms->oldmessages);
-		dcnum = vms->oldmessages - lastnum;
-		if (dcnum)
-			res = say_and_wait(chan, dcnum, chan->language);
-		if (!res && lastnum) {
-			if (lastnum == 1) 
-				res = ast_play_and_wait(chan, "digits/ru/odno");
-			else
-				res = say_and_wait(chan, lastnum, chan->language);
-		}
+	    	lastnum = vms->oldmessages;
 
+		res = ast_say_number(chan, vms->oldmessages, AST_DIGIT_ANY, chan->language, "o");
+
 		if (!res)
-			res = ast_play_and_wait(chan, (lastnum == 1) ? "vm-staroe" : "vm-staryh");
+			res = ast_play_and_wait(chan, slavic_counted_adjective(vms->oldmessages) ? "vm-staryh" : "vm-staroe");
 	}
 
-	if (!res && !vms->newmessages && !vms->oldmessages) {
-		lastnum = 0;
-		res = ast_play_and_wait(chan, "vm-no");
-	}
-
 	if (!res) {
-		switch (lastnum) {
-		case 1:
-			res = ast_play_and_wait(chan, "vm-soobshenie");
-			break;
-		case 2:
-		case 3:
-		case 4:
-			res = ast_play_and_wait(chan, "vm-soobsheniya");
-			break;
-		default:
-			res = ast_play_and_wait(chan, "vm-soobsheniy");
-			break;
+		if(!vms->newmessages && !vms->oldmessages) {
+			res = ast_play_and_wait(chan, "vm-no");
+		} else {
+			switch (slavic_counted_noun(lastnum)) {
+			case 0:
+				res = ast_play_and_wait(chan, "vm-soobshenie");
+				break;
+			case 1:
+				res = ast_play_and_wait(chan, "vm-soobsheniya");
+				break;
+			case 2:
+				res = ast_play_and_wait(chan, "vm-soobsheniy");
+				break;
+			}
 		}
 	}
 
